OpenTTD Source: src/saveload/saveload_internal.h File Reference

OpenTTD Source 14.0-beta3

Functions | Variables
saveload_internal.h File Reference
`#include "../company_manager_face.h"`
`#include "../order_base.h"`
`#include "../engine_type.h"`
`#include "saveload.h"`

Go to the source code of this file.

## Functions
void | InitializeOldNames ()
| Initialize the old names table memory.
StringID | RemapOldStringID (StringID s)
| Remap a string ID from the old format to the new format. More...
std::string | CopyFromOldName (StringID id)
| Copy and convert old custom names to UTF-8. More...
void | ResetOldNames ()
| Free the memory of the old names array. More...
void | ResetOldWaypoints ()
void | MoveBuoysToWaypoints ()
| Perform all steps to upgrade from the old station buoys to the new version that uses waypoints. More...
void | MoveWaypointsToBaseStations ()
| Perform all steps to upgrade from the old waypoints to the new version that uses station. More...
void | AfterLoadVehicles (bool part_of_load)
| Called after load to update coordinates. More...
void | FixupTrainLengths ()
| Fixup old train spacing.
void | AfterLoadStations ()
void | AfterLoadRoadStops ()
| (Re)building of road stop caches after loading a savegame.
void | ResetLabelMaps ()
void | AfterLoadLabelMaps ()
void | AfterLoadStoryBook ()
| Called after load to trash broken pages.
void | AfterLoadLinkGraphs ()
| Spawn the threads for running link graph calculations. More...
void | AfterLoadCompanyStats ()
| Rebuilding of company statistics after loading a savegame.
void | UpdateHousesAndTowns ()
| Check and update town and house values. More...
void | UpdateOldAircraft ()
| need to be called to load aircraft from old version
void | SaveViewportBeforeSaveGame ()
void | ResetViewportAfterLoadGame ()
void | ConvertOldMultiheadToNew ()
| Converts all trains to the new subtype format introduced in savegame 16.2 It also links multiheaded engines or make them forget they are multiheaded if no suitable partner is found.
void | ConnectMultiheadedTrains ()
| Link front and rear multiheaded engines to each other This is done when loading a savegame.
void | ResetTempEngineData ()
Engine * | GetTempDataEngine (EngineID index)
void | CopyTempEngineData ()
| Copy data from temporary engine array into the real engine pool.
CompanyManagerFace | ConvertFromOldCompanyManagerFace (uint32_t face)
| Converts an old company manager's face format to the new company manager's face format. More...
Order | UnpackOldOrder (uint16_t packed)
| Unpacks a order from savegames made with TTD(Patch) More...

## Variables
int32_t | _saved_scrollpos_x
int32_t | _saved_scrollpos_y
ZoomLevel | _saved_scrollpos_zoom
SavegameType | _savegame_type
| type of savegame we are loading
uint32_t | _ttdp_version
| version of TTDP savegame (if applicable)

## Detailed Description

Declaration of functions used in more save/load files

Definition in file saveload_internal.h.

## Function Documentation

## ◆ AfterLoadLinkGraphs()

void AfterLoadLinkGraphs | ( |  | ) |

Spawn the threads for running link graph calculations.

Has to be done after loading as the cargo classes might have changed.

Definition at line 232 of file linkgraph_sl.cpp.

References _network_server, _networking, AfterLoad_LinkGraphPauseControl(), SpecializedStation< Station, false >::GetIfValid(), LinkGraphJob::Graph(), LinkGraphSchedule::instance, IsSavegameVersionBefore(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_link_graph_pool >::Iterate(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_link_graph_job_pool >::Iterate(), LinkGraph::Size(), SLV_191, LinkGraphSchedule::SpawnAll(), and BaseStation::xy.

## ◆ AfterLoadVehicles()

void AfterLoadVehicles | ( | bool | part_of_load | ) |

Called after load to update coordinates.

So we can set the #previous and #first pointers while loading.

For instantiating the shared vehicle chain.

Definition at line 255 of file vehicle_sl.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_vehicle_pool >::Iterate().

## ◆ ConvertFromOldCompanyManagerFace()

CompanyManagerFace ConvertFromOldCompanyManagerFace | ( | uint32_t | face | ) |

Converts an old company manager's face format to the new company manager's face format.

Meaning of the bits in the old face (some bits are used in several times):

- 4 and 5: chin
- 6 to 9: eyebrows
- 10 to 13: nose
- 13 to 15: lips (also moustache for males)
- 16 to 19: hair
- 20 to 22: eye colour
- 20 to 27: tie, ear rings etc.
- 28 to 30: glasses
- 19, 26 and 27: race (bit 27 set and bit 19 equal to bit 26 = black, otherwise white)
- 31: gender (0 = male, 1 = female)

Parameters

  face | the face in the old format

Returns
  the face in the new format

Definition at line 45 of file company_sl.cpp.

References ClampU(), ETHNICITY_BLACK, GB(), GE_WF, GE_WM, GENDER_FEMALE, HasBit(), ScaleCompanyManagerFaceValue(), SetBit(), and SetCompanyManagerFaceBits().

## ◆ CopyFromOldName()

std::string CopyFromOldName | ( | StringID | id | ) |

Copy and convert old custom names to UTF-8.

They were all stored in a 512 by 32 (200 by 24 for TTO) long string array and are now stored with stations, waypoints and other places with names.

Parameters

  id | the StringID of the custom name to clone.

Returns
  the clones custom name.

Definition at line 61 of file strings_sl.cpp.

References GetStringTab().

Referenced by FixOldVehicles().

## ◆ MoveBuoysToWaypoints()

void MoveBuoysToWaypoints | ( |  | ) |

Perform all steps to upgrade from the old station buoys to the new version that uses waypoints.

This includes some old saveload mechanics.

Definition at line 45 of file station_sl.cpp.

References BaseStation::build_date, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_station_pool >::CanAllocateItem(), BaseStation::delete_ctr, GetStationIndex(), GetTileOwner(), HVOT_WAYPOINT, INVALID_TILE, IsInsideBS(), IsTileType(), SpecializedStation< Station, false >::Iterate(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_orderlist_pool >::Iterate(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_vehicle_pool >::Iterate(), Tile::m6(), MP_STATION, Town::name, BaseStation::name, Order::next, BaseStation::owner, OWNER_NONE, SB(), BaseStation::string_id, BaseStation::town, Waypoint::town_cn, UpdateWaypointOrder(), VEH_SHIP, and VEH_TRAIN.

## ◆ MoveWaypointsToBaseStations()

void MoveWaypointsToBaseStations | ( |  | ) |

Perform all steps to upgrade from the old waypoints to the new version that uses station.

This includes some old saveload mechanics.

Definition at line 67 of file waypoint_sl.cpp.

References _old_waypoints, AllocateSpecToStation(), BaseStation::build_date, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_station_pool >::CanAllocateItem(), Debug, BaseStation::delete_ctr, FACIL_TRAIN, BaseStation::facilities, GB(), NewGRFClass< Tspec, Tid, Tmax >::Get(), GetRailTileType(), GetRailType(), NewGRFClass< Tspec, Tid, Tmax >::GetSpecCount(), GetTileOwner(), StationSpec::grf_prop, GRFFilePropsBase< Tcnt >::grffile, HasBit(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, IsSavegameVersionBefore(), IsTileType(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_orderlist_pool >::Iterate(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_vehicle_pool >::Iterate(), GRFFilePropsBase< Tcnt >::local_id, Tile::m2(), Tile::m3(), Tile::m4(), Tile::m5(), MakeRailWaypoint(), MP_RAILWAY, BaseStation::name, Order::next, BaseStation::owner, BaseStation::rect, SetCustomStationSpecIndex(), SetRailStationReservation(), Map::Size(), SlError(), SlErrorCorrupt(), SLV_100, SLV_17, STAT_CLASS_WAYP, BaseStation::string_id, BaseStation::town, Waypoint::town_cn, UpdateWaypointOrder(), and VEH_TRAIN.

## ◆ RemapOldStringID()

StringID RemapOldStringID | ( | StringID | s | ) |

Remap a string ID from the old format to the new format.

Parameters

  s | StringID that requires remapping

Returns
  translated ID

Definition at line 30 of file strings_sl.cpp.

## ◆ ResetOldNames()

void ResetOldNames | ( |  | ) |

Free the memory of the old names array.

Should be called once the old names have all been converted.

Definition at line 102 of file strings_sl.cpp.

References _old_name_array, and free().

## ◆ UnpackOldOrder()

Order UnpackOldOrder | ( | uint16_t | packed | ) |

Unpacks a order from savegames made with TTD(Patch)

Parameters

  packed | packed order

Returns
  unpacked order

Definition at line 92 of file order_sl.cpp.

## ◆ UpdateHousesAndTowns()

void UpdateHousesAndTowns | ( |  | ) |

Check and update town and house values.

Checked are the HouseIDs. Updated are the town population the number of houses per town, the town radius and the max passengers of the town.

Definition at line 67 of file town_sl.cpp.

References GetCleanHouseType(), IsTileType(), MP_HOUSE, NEW_HOUSE_OFFSET, and Map::Size().